var settingsRefresh=5;
var xmlData=null;
var xmlPlot=null;
var xml1 = null;

var leftPad = function(n) 
{
	n = "" + n;
	return n.length == 1 ? "0" + n : n;
};

function init() {
	System.Gadget.settingsUI="settings.html";
	System.Gadget.Flyout.file="graphic.html";
	System.Gadget.onSettingsClosed=settingsClosed;
	if (System.Gadget.Settings.read("Refresh")!='') {
		settingsRefresh=System.Gadget.Settings.read("Refresh");
	} else {
		System.Gadget.Settings.write("Refresh", settingsRefresh);
	}
	initLayout();
	loadData();
    self.setTimeout( "onTimer()", 60 * 1000 * settingsRefresh );
}

function initLayout() {
}

var DataComplete=false;

function settingsClosed() {
	settingsRefresh=System.Gadget.Settings.read("refresh");
	DataComplete=false;
	onTimer();
}

function onTimer() {
//    var date = new Date(System.Time.getLocalTime(System.Time.currentTimeZone));
//	document.getElementById('statuser').style.color = '#000';
//	document.getElementById('statuser').innerText = date.getTime();//date.getHours() + ':' + date.getMinutes() + ':' + date.getSeconds();

	loadData();
    self.setTimeout( "onTimer()", 60 * 1000 * (	DataComplete?settingsRefresh:1));
}

function showExtendedFlyout() {
	if (System.Gadget.Flyout.show==false) {
		if (DataComplete) {
			System.Gadget.Flyout.file = "weatherExtended.html";
			System.Gadget.Flyout.show=true;
			System.Gadget.Flyout.onHide = blankFunction;
		}
	} else {
		System.Gadget.Flyout.show=false;
	}
}

function blankFunction() {}

function loadData() {
	DataComplete=false;
    var date = new Date(System.Time.getLocalTime(System.Time.currentTimeZone));
    var url = "http://www.shadrinsk.info/temperature.xml?rnd="+date.getTime();
    var urlplot = "http://www.shadrinsk.info/temperature_plot.xml?rnd="+date.getTime();
	document.getElementById('statuser').innerText = date.getHours()+":"+leftPad(date.getMinutes())
		+":"+leftPad(date.getSeconds())+"/"+settingsRefresh;
	document.getElementById('statuser').style.color = '#F00';
	try {
		req = new ActiveXObject("Microsoft.XMLHTTP");
		if (req) {
			req.open("GET", url, false);
			req.send();
			if (req.status == 200) {
				xmlData = req.responseXML.documentElement;
				parseData(xmlData);
				document.getElementById('statuser').style.color = '#AAA';
				DataComplete=true;
			} else {

			}
			req.open("GET", urlplot, false);
			req.send();
			if (req.status == 200) {	
				xml1 = req.responseXML.documentElement;
				parseDataPlot(req.responseXML.documentElement);
				document.getElementById('statuser').style.color = '#AAA';
			} else {

			}
		}
	} catch (e) 
	{
	}

//	if(DataComplete)
//		document.getElementById('statuser').style.color = '#00F';
}

function parseData(xmlData)
{
	tempNodes=xmlData.getElementsByTagName('current');
	for (count=0;count<tempNodes.length;count++) 
	{
		var t = tempNodes.item(count).getAttribute('tc');
		document.getElementById('curt').innerText = t;
		var d = tempNodes.item(count).getAttribute('ty') 
			+ "-" + tempNodes.item(count).getAttribute('tm') 
			+ "-" + tempNodes.item(count).getAttribute('td') 
			+ " " + tempNodes.item(count).getAttribute('tt') ;
		document.getElementById('curtime').innerText = d;
	}
}

function parseDataPlot(xml)
{
	xmlPlot = null;
	var utc = 6 * 60 * 60 * 1000;
	if(xml!=null) {
		data = [];
		d24 = [];
		$(xml).find("point").each( function() 
			{
				data.push([$(this).attr("tu")*1000+utc, $(this).attr("tc")]);
				d24.push([$(this).attr("tu")*1000+utc, $(this).attr("tm")]);
			}
		)
		 xmlPlot = [{data: d24, label: "  24 : "} 
		 ,  { data: data, 
		 		label: " : &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;"} ];
	}
}

function settingsClosed() {
	if (System.Gadget.Settings.read("Refresh")!='') {
		settingsRefresh=System.Gadget.Settings.read("Refresh");
	    loadData();
	}
	document.getElementById('statuser').innerText = settingsRefresh;
}
